# build

```bash
    build [options] [gmake-options] [<targets>]
```

          Build the productions (shared libraries,  plugins,  executables  and
          tests) for the current project area.

          OPTIONS

          -c, --convertxml
             Obsolete: Convert any old-style BuildFile in to new BuildFile.xml

          -f, --fast
             Skip checking the internal SCRAM cache update and go straight  to
             build/gamke

          --ignore-arch
             Avoid SCRAM warning about architecture mismatch e.g. compiling on
             SLC5 machine an slc6_* based release.

          -r, --reset
             Reset/re-generate all internal SCRAM caches for your  development
             area.

          -t, --testrun
             Do not run gmake but only do any internal SCRAM caches updates.

          -v, --verbose
             For more verbose output from the underlaying gmake process

          GMAKE OPTIONS
          You  can pass any gmake command-line option which does not conflicit
          with 'scram build' options. e.g.

          -j [N], --jobs[=N]
             Allow N jobs at once; infinite jobs with missing N

          -k, --keep-going
             Keep going when some targets can't be made

          TARGETS

          help
             Shows what SCRAM will build for your current working directory.

          clean
             Clean up all the products built/generated by SCRAM.

          python
             To just build python i.e. creating sym-links and compiling python
             modules.

          runtests
             Build  and  run all tests for the project, or package-level tests
             only

          unittests
             Same as runtests but does not try to build the test first.

          checker
             Run LLVM static checkers

          dxr
             Generate DXR indexes for the release.

          gindices
             Generate glimpse indexes for the release.

          enable-biglib disable-biglib check-biglib
             Disable/enable/check big EDM plugins

          updateclassversion
             Run  the  edmCheckClassVersion  and   generate   new   src/<pack-
             age>/classes_def.xml.generated file.

          prebuild postbuild
             Execute any pre/post-build target for the project e.g. generating
             various source file for root/lcg dictionaries etc.

          src release release-build all project
             Build all products  (shared  libs,  plugins,  binaries)  for  the
             project

          <path>
             Build  all  products  (shared  libs, plugins, binaries) and their
             dependencies for src/<path>

          runtime
             Dump the runtime environment used at build time.

          ProjectRename projectrename PROJECTRENAME
             Fix the project area which was move/renamed after its creation.

          ExternalLinks ToolUpdated
             Re-create symblinks for externals tools.

          echo_<tool|package>_USED_BY
             Shows what depends on <tool> or <package> e.g.

                scram build echo_boost_USED_BY
                scram build echo_FWCore/Framework_USED_BY

             should show what depend on boost and FWCore/Framework

          echo_<tool|package>_USES
             Shows what is the dependency of <tool> or <package>

          echo_<productname>_ORIGIN
             Shows from which package <productname> was built.

          echo_<variable>
             Shows the value of a variable used by the game e.g.

                scram build echo_CXXFLAGS

             shows the default flags used by the CXX compilers
